#define USE_AND_OR /* To enable AND_OR mask setting */
#include "timer.h"
#include "dpslp.h"
#define FCY 16000000UL
#include <libpic30.h>
#include <ports.h>
#include "PPS.h"

// *****************************************************************************
// *****************************************************************************
// Configuration Bits
// *****************************************************************************
// *****************************************************************************

        _CONFIG1(WDTPS_PS1 & FWPSA_PR32 & WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & GWRP_OFF & GCP_OFF & JTAGEN_OFF)
        _CONFIG2(POSCMOD_HS & I2C1SEL_PRI & IOL1WAY_OFF & OSCIOFNC_ON & FCKSM_CSDCMD & FNOSC_PRIPLL & PLL96MHZ_ON & PLLDIV_NODIV & IESO_ON)
        _CONFIG3(WPFP_WPFP0 & SOSCSEL_IO & WUTSEL_LEG & WPDIS_WPDIS & WPCFG_WPCFGDIS & WPEND_WPENDMEM)
        _CONFIG4(DSWDTPS_DSWDTPS3 & DSWDTOSC_LPRC & RTCOSC_SOSC & DSBOREN_OFF & DSWDTEN_OFF)

// *****************************************************************************

void __attribute__ ((interrupt,no_auto_psv)) _T23Interrupt (void)
{
	CloseINT0();
	ConfigINT0(INT_ENABLE | FALLING_EDGE_INT | INT_PRI_1);
	GotoDeepSleep(); //This function puts the device into deep sleep
}


int main(void)
{
	if(IsResetFromDeepSleep()==TRUE) //if this is the reset after the deep_sleep wakup...then do this
	{
		ReleaseDeepSleep(); //Release the Deep sleep (IO configuration)
	}

    CLKDIV = 0;        // system clock: 32MHz
	AD1PCFG = 0xffff; /*set AN pins to digital pin */

	TRISB = 0x7fff;	/* set PORTB RB15 (pin #26) to output*/
					/* "0" corresponds to "o"utput and "1" to "i"nput */

	LATBbits.LATB15=1;

//	CNPU1=0x0002;	/* Pull up CN1 pin  pin#11*/
	CNPU2=0x80;	//pin#16 pull-up CN23

	ConfigIntTimer23(T23_INT_ON|T23_INT_PRIOR_1);/*Enable Interrupt*/
	OpenTimer23(T23_ON|T23_PS_1_256,0x98968); //Timer is configured for 10 sec

	while(1){
		if(PORTBbits.RB7==0){
			CloseTimer23(); 

			ConfigIntTimer23(T23_INT_ON|T23_INT_PRIOR_1);/*Enable Interrupt*/
			OpenTimer23(T23_ON|T23_PS_1_256,0x98968); //Timer is configured for 10 sec
		}
		else{
			LATBbits.LATB15=1;
	    	__delay32(8000000UL); // 500ms delay
			LATBbits.LATB15 =0;
			__delay32(8000000UL); // 500ms delay
		}
	}
}

